/*
 * $RCSfile: OperationFailedException.java,v $
 * $Date: 2009/11/21 00:00:31 $
 * $Revision: 1.4 $
 * jEdit:tabSize=4:indentSize=4:collapseFolds=1:
 */

package com.acces.aiousb;

// {{{ imports
import java.lang.*;
// }}}

// {{{ class OperationFailedException

/**
 * Class OperationFailedException is thrown whenever an operation attempted on a device fails. The
 * message is either generated by this Java class library or consists of the string representation
 * of an error code returned by the AIOUSB module.
 */

public class OperationFailedException extends RuntimeException {

	/**
	 * Constructs the exception from an AIOUSB module error code.
	 * @param result AIOUSB module result code.
	 */

	public OperationFailedException( int result ) {
		super( USBDeviceManager.getResultCodeAsString( result ) );
	}	// OperationFailedException()

	/**
	 * Constructs the exception from a simple string message.
	 * @param message The text of the message.
	 */

	public OperationFailedException( String message ) {
		super( message );
	}	// OperationFailedException()

}	// class OperationFailedException

// }}}

/* end of file */
